package main

import (
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
	"time"
)

func main() {
	weatherID := []int{}
	apiKey := "f9d230f00d9ccdba49a97e043333d410"
	latitude := 39.7283514
	longitude := 116.4888702
	maxRetries := 5
	retryDelay := time.Second * 2

	var data map[string]interface{}

	for retries := 0; retries < maxRetries; retries++ {
		url := fmt.Sprintf("https://api.openweathermap.org/data/2.5/weather?lat=%f&lon=%f&appid=%s", latitude, longitude, apiKey)

		resp, err := http.Get(url)
		if err != nil {
			fmt.Println("Error:", err)
			time.Sleep(retryDelay)
			continue
		}
		defer resp.Body.Close()

		body, err := ioutil.ReadAll(resp.Body)
		if err != nil {
			fmt.Println("Error reading response:", err)
			time.Sleep(retryDelay)
			continue
		}

		if err := json.Unmarshal(body, &data); err != nil {
			fmt.Println("Error parsing JSON:", err)
			time.Sleep(retryDelay)
			continue
		}

		// Successfully retrieved data
		break
	}

	if data == nil {
		fmt.Println("Failed to retrieve data after maximum retries.")
		return
	}

	mainData := data["main"].(map[string]interface{})
	temperature := mainData["temp"].(float64) - 273.15
	humidity := mainData["humidity"].(float64)

	for _, w := range data["weather"].([]interface{}) {
		weather := w.(map[string]interface{})
		weatherID = append(weatherID, int(weather["id"].(float64)))
	}

	fmt.Printf("当前位置的天气状况/温度/湿度：%v/%.2f/%.2f\n", weatherID, temperature, humidity)
}
