package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	Framenum    int64 = 0
	param       entity.PjisuvParam
	ObjectSlice = make(map[uint32][][]float32)
)

func main() {
	ticker := time.NewTicker(5 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}
func findIndex(lst []float32, target float32) int {
	for i, v := range lst {
		if v == target {
			return i
		}
	}
	return -1
}

func isCrossAndOcclusion(id uint32, ObjectList [][]float32, ObjectSlice map[uint32][][]float32) bool {
	for i := 0; i < len(ObjectList[0]); i++ {
		xi := ObjectList[0][i]
		yi := ObjectList[1][i]
		diff_hi := ObjectList[2][i]
		Type := ObjectList[4][0]
		//if xi >= 0 && yi <= -3 && diff_hi <= 120 && diff_hi >= 60 && Type == 4.0 {//理论条件
		if xi >= 0 && yi <= -3 && diff_hi >= 0 && Type != 100.0 { //简化条件
			startFrame1 := ObjectList[3][i]

			for j := 0; j < len(ObjectList[0])-i-1; j++ {
				xj := ObjectList[0][j]
				yj := ObjectList[1][j]
				diff_hj := ObjectList[2][j]
				//if xj >= 0 && xj <= 25 && yj >= 1 && diff_hj <= 120 && diff_hj >= 60 {//理论条件
				if xj >= 0 && xj <= 25 && yj >= 1 && diff_hj >= 0 { //简化条件
					startFrame2 := ObjectList[3][j]
					for this_id, objValue := range ObjectSlice {
						if this_id != id {
							this_startFrame_index1 := findIndex(objValue[3], startFrame1)
							this_startFrame_index2 := findIndex(objValue[3], startFrame2)
							this_type := objValue[4][0]
							//fmt.Println(objValue[0][this_startFrame_index2], xj)
							if this_startFrame_index1 != -1 && this_startFrame_index2 != -1 {
								//if objValue[0][this_startFrame_index1] >= 2 && objValue[0][this_startFrame_index1] < xi-1 && objValue[1][this_startFrame_index1] < 0 && objValue[1][this_startFrame_index1] > yi && objValue[0][this_startFrame_index2] >= 1 && objValue[0][this_startFrame_index2] < xj-1 && objValue[1][this_startFrame_index2] < 0 && (this_type == 2.0 || this_type == 3.0) {//理论条件
								if objValue[0][this_startFrame_index1] >= 2 && objValue[0][this_startFrame_index1] < xi-1 && objValue[1][this_startFrame_index1] < 0 && objValue[1][this_startFrame_index1] > yi && objValue[0][this_startFrame_index2] >= 1 && objValue[0][this_startFrame_index2] < xj-1 && objValue[1][this_startFrame_index2] < 0 && (this_type != 100.0) { //简化条件
									return true
								}
							}
						} else {
							continue
						}
					}
				}
			}
		}
	}
	return false
}
func FinalCallback() {

	for id, objValue := range ObjectSlice {
		//fmt.Println(objValue)
		//fmt.Println("------------------------------------------------")

		if len(objValue[0]) <= 10 || !isCrossAndOcclusion(id, objValue, ObjectSlice) {
			continue
		}
		event_lable := "CBNA"
		fmt.Println(event_lable)
		ObjectSlice = make(map[uint32][][]float32)
	}

}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.YawOfCicvLocation = data.Yaw

}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	Framenum += 1
	for _, obj := range data.Objs {
		if math.Abs(float64(obj.X)) >= 80 || math.Abs(float64(obj.Y)) >= 30 {
			continue
		}
		if _, ok := ObjectSlice[obj.Id]; !ok {
			ObjectSlice[obj.Id] = [][]float32{{}, {}, {}, {}, {}}
		}
		//absspeed := math.Sqrt(math.Pow(float64(obj.Vxabs), 2)+math.Pow(float64(obj.Vyabs), 2)) * 3.6
		ObjectSlice[obj.Id][0] = append(ObjectSlice[obj.Id][0], obj.X)
		ObjectSlice[obj.Id][1] = append(ObjectSlice[obj.Id][1], obj.Y)
		diffh := (float64(obj.Heading - float32(param.YawOfCicvLocation)))
		if diffh < -180.0 {
			diffh = 360.0 + diffh
		} else if diffh > 180.0 {
			diffh = 360.0 - diffh
		} else {
			diffh = math.Abs(diffh)
		}
		ObjectSlice[obj.Id][2] = append(ObjectSlice[obj.Id][2], float32(diffh))
		ObjectSlice[obj.Id][3] = append(ObjectSlice[obj.Id][3], float32(Framenum))
		ObjectSlice[obj.Id][4] = append(ObjectSlice[obj.Id][4], float32(obj.Type))

		//ObjectSlice[obj.Id][3] = append(ObjectSlice[obj.Id][3], float32(absspeed))
		if len(ObjectSlice[obj.Id][0]) >= 200 {
			ObjectSlice[obj.Id][0] = ObjectSlice[obj.Id][0][1:]
			ObjectSlice[obj.Id][1] = ObjectSlice[obj.Id][1][1:]
			ObjectSlice[obj.Id][2] = ObjectSlice[obj.Id][2][1:]
			ObjectSlice[obj.Id][3] = ObjectSlice[obj.Id][3][1:]
			ObjectSlice[obj.Id][4] = ObjectSlice[obj.Id][4][1:]

		}

	}
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
