package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"os"
	"os/signal"
	"time"
)

// 触发器名称是顿挫
var (
	param       entity.PjisuvParam
	threshold   = 0.04
	AccelXSlice = []float64{}
)

func main() {
	ticker := time.NewTicker(2 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func countChanges(slice []float64) int {
	count := 0
lable1:
	for i := 0; i < len(slice); {
		if slice[i] <= -threshold || slice[i] > threshold {
			for j := 0; j < len(slice)-i-1; j++ {
				if (slice[i] <= -threshold && slice[1+i+j] >= threshold) || (slice[i] >= threshold && slice[1+i+j] <= -threshold) {
					count++
					i = i + j + 1
					continue lable1
				}
			}
			break lable1
		} else {
			i++
		}

	}
	return count
}

func FinalCallback() {
	count := countChanges(AccelXSlice)
	//fmt.Println(AccelXSlice)
	if count >= 3 {

		event_lable := "Cadence"
		fmt.Println(event_lable)
	}
	if len(AccelXSlice) >= 600 {
		AccelXSlice = []float64{}
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	//AbsAccel := math.Sqrt(math.Pow(data.AccelX, 2) + math.Pow(data.AccelY, 2))
	AccelXSlice = append(AccelXSlice, data.AccelX)

}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
