package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
)

var (
	Maxlenobj           int32 = 0
	param               entity.PjisuvParam
	PreCloseTargetSlice = []uint32{}
)

func main() {

	go listener()
	for {
		select {}
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.AbsSpeed = math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))

}
func IsDisappears(PreCloseTargetSlice []uint32, perceptionslice []uint32) bool {
	flag := false
	if len(PreCloseTargetSlice) > 0 {
	lable1:
		for i := 0; i <= len(PreCloseTargetSlice)-1; i++ {
			PreID := PreCloseTargetSlice[i]
			for _, perceptionID := range perceptionslice {
				if PreID == perceptionID {
					continue lable1
				}
			}
			//fmt.Println("CloseTargetDisappears")
			return true
		}
	}
	return flag
}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	NowCloseTargetSlice := []uint32{}
	perceptionslice := []uint32{}
	for _, obj := range data.Objs {
		perceptionslice = append(perceptionslice, obj.Id)
		if math.Abs(float64(obj.X)) <= 10 && math.Abs(float64(obj.Y)) <= 10 {
			NowCloseTargetSlice = append(NowCloseTargetSlice, obj.Id)
		}
	}
	//fmt.Println("PreCloseTargetSlice=", PreCloseTargetSlice)
	//fmt.Println("perceptionslice=", perceptionslice)
	if IsDisappears(PreCloseTargetSlice, perceptionslice) {
		eventLabel := "CloseTargetDisappears"
		fmt.Println(eventLabel)
	}
	PreCloseTargetSlice = NowCloseTargetSlice

}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
