package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
)

var (
	param entity.PjisuvParam
	count int = 0
)

func main() {
	go listener()
	for {
		select {}
	}
}

func CallbackDataRead(data *pjisuv_msgs.Retrieval) {
	if data.GearPos == 2 {
		if param.AbsSpeed >= 0.5 {
			event_lable := "Creeping"
			fmt.Println(event_lable)
		}
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {

	if count%10 == 0 {
		param.AbsSpeed = math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))
	}
	count++

}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subDataRead, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/data_read",
		Callback: CallbackDataRead,
	})
	if err != nil {
		panic(err)
	}
	defer subDataRead.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
