package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	param      entity.PjisuvParam
	threshold  int = 1500
	SpeedSlice     = []float64{}
)

func main() {
	ticker := time.NewTicker(6 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func countChanges(slice []float64) int {
	count := 0
lable1:
	for i := 0; i < len(slice); {
		if slice[i] >= 2 {
			for j := 0; j < len(slice)-i-1; j++ {
				if slice[1+i+j] <= 0.5 {
					count++
					//fmt.Println("stop!!")
					i = i + j + 1
					continue lable1
				}
			}
			break lable1
		} else {
			i++
		}

	}
	return count
}

func FinalCallback() {
	count := countChanges(SpeedSlice)
	//fmt.Println(AccelXSlice)
	if count >= 3 {
		event_lable := "FrequentStartsAndStops"
		fmt.Println(event_lable)
		SpeedSlice = []float64{}

	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	Aspeed := math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))
	SpeedSlice = append(SpeedSlice, Aspeed)
	if len(SpeedSlice) > threshold {
		SpeedSlice = SpeedSlice[1:]
	}

}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
