package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	Maxlenobj   int32 = 0
	param       entity.PjisuvParam
	ObjectSlice = make(map[uint32][][]float32)
)

func main() {
	ticker := time.NewTicker(3 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func isWrongDirection(ObjectList [][]float32) bool {
	//fmt.Println("-------------------------------------------------------------------------------------------------------------")
	//fmt.Println(ObjectList)
	for i, heading := range ObjectList[2] {
		objXi := ObjectList[0][i]
		objYi := ObjectList[1][i]
		Anglei := math.Abs(float64(heading - float32(param.YawOfCicvLocation)))
		//fmt.Println("objXi=", objXi)
		if math.Abs(float64(objYi)) <= 1.5 && math.Abs(param.AngularVelocityZOfCicvLocation) <= 0.6 && objXi >= 15 && Anglei <= 200 && Anglei >= 160 {
			//fmt.Println(objY)
			for j := 0; j < len(ObjectList[1])-i-1; j++ {
				objXij := ObjectList[0][1+i+j]
				objYij := ObjectList[1][1+i+j]
				//fmt.Println("objXij=", objXij)
				if math.Abs(float64(objYij)) <= 1.5 && math.Abs(param.AngularVelocityZOfCicvLocation) <= 0.6 && objXij <= 10 {
					return true
				}
			}
		}
	}
	return false
}
func FinalCallback() {

	for _, objValue := range ObjectSlice {
		//fmt.Println(objValue)
		//fmt.Println("------------------------------------------------")
		Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
		if len(objValue[0]) <= 10 || !isWrongDirection(objValue) {
			continue
		}
		event_lable := "FrontCarDrivingWrongDirection"
		ObjectSlice = make(map[uint32][][]float32)
		fmt.Println(event_lable)
	}
	if Maxlenobj >= 250 {
		ObjectSlice = make(map[uint32][][]float32)
		Maxlenobj = 0
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.AngularVelocityZOfCicvLocation = data.AngularVelocityZ
	param.YawOfCicvLocation = data.Yaw

}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	for _, obj := range data.Objs {
		if obj.X <= 2 || math.Abs(float64(obj.Y)) >= 80 {
			continue
		}
		if _, ok := ObjectSlice[obj.Id]; !ok {
			ObjectSlice[obj.Id] = [][]float32{{}, {}, {}}
		}
		ObjectSlice[obj.Id][0] = append(ObjectSlice[obj.Id][0], obj.X)
		ObjectSlice[obj.Id][1] = append(ObjectSlice[obj.Id][1], obj.Y)
		ObjectSlice[obj.Id][2] = append(ObjectSlice[obj.Id][2], obj.Heading)
	}
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
