package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"os"
	"os/signal"
	"time"
)

var (
	param        entity.PjisuvParam
	threshold    = 0.04
	GearPosSlice = []int16{}
)

func main() {
	ticker := time.NewTicker(2 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func countChanges(slice []int16) int {
	count := 0
	for i := 0; i < len(slice)-1; i++ {
		if slice[i] != slice[i+1] {
			count++
		}
	}
	return count
}

func FinalCallback() {
	count := countChanges(GearPosSlice)
	//fmt.Println(AccelXSlice)
	if count >= 2 {

		event_lable := "GearJump"
		fmt.Println(event_lable)
	}
	GearPosSlice = []int16{}

}

func CallbackDataRead(data *pjisuv_msgs.Retrieval) {
	//AbsAccel := math.Sqrt(math.Pow(data.AccelX, 2) + math.Pow(data.AccelY, 2))
	GearPosSlice = append(GearPosSlice, data.GearPos)

}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subDataRead, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/data_read",
		Callback: CallbackDataRead,
	})
	if err != nil {
		panic(err)
	}
	defer subDataRead.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
