package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"os"
	"os/signal"
	"time"
)

// 触发器名称是顿挫
var (
	param            entity.PjisuvParam
	threshold        float64 = 60.0
	ActStrWhAngSlice         = []float64{}
	numcount                 = 0
)

func main() {
	ticker := time.NewTicker(6 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func countChanges(slice []float64) int {
	count := 0
lable1:
	for i := 0; i < len(slice); {
		if slice[i] <= -threshold || slice[i] > threshold {
			for j := 0; j < len(slice)-i-1; j++ {
				if (slice[i] <= -threshold && slice[1+i+j] >= threshold) || (slice[i] >= threshold && slice[1+i+j] <= -threshold) {
					count++
					i = i + j + 1
					continue lable1
				}
			}
			break lable1
		} else {
			i++
		}

	}
	return count
}

func FinalCallback() {
	count := countChanges(ActStrWhAngSlice)
	//fmt.Println(AccelXSlice)
	if count >= 3 {

		event_lable := "HuaLong"
		fmt.Println(event_lable)
	}
	ActStrWhAngSlice = []float64{}
}

func CallbackDataRead(data *pjisuv_msgs.Retrieval) {
	if numcount%10 == 0 {
		ActStrWhAngSlice = append(ActStrWhAngSlice, data.ActStrWhAng)
		numcount = 0
	}
	numcount++
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/data_read",
		Callback: CallbackDataRead,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
