package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	Maxlenobj   int32 = 0
	param       entity.PjisuvParam
	ObjectSlice = make(map[uint32][][]float32)
)

func main() {
	ticker := time.NewTicker(2 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}
func getMaxValue(slice []int) int {
	max := slice[0]
	for _, value := range slice {
		if value > max {
			max = value
		}
	}
	return max
}
func isParallel(ObjectList [][]float32) bool {
	numParallelslice := []int{0}
	numParallel := 0
lable1:
	for i := 0; i < len(ObjectList[1]); i++ {
		objx := ObjectList[0][i]
		objy := ObjectList[1][i]
		if math.Abs(float64(objx)) <= 2 && math.Abs(float64(objy)) <= 4.5 {
			for j := 0; j < len(ObjectList[1])-i-1; j++ {
				objxj := ObjectList[0][1+i+j]
				objyj := ObjectList[1][1+i+j]
				if math.Abs(float64(objxj)) <= 2 && math.Abs(float64(objyj)) <= 4.5 {
					numParallel++
				} else {
					i = i + j + 1
					numParallelslice = append(numParallelslice, numParallel)
					numParallel = 0
					continue lable1
				}
			}
			numParallelslice = append(numParallelslice, numParallel)
			break lable1
		} else {
			i++
		}
	}
	maxValue := getMaxValue(numParallelslice)
	fmt.Println(maxValue)
	if maxValue >= 100 {
		return true
	} else {
		return false
	}
}
func FinalCallback() {

	for _, objValue := range ObjectSlice {
		//fmt.Println(objValue)
		//fmt.Println("------------------------------------------------")
		Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
		if len(objValue[0]) <= 10 || !isParallel(objValue) || param.AbsSpeed <= 1 {
			continue
		}
		event_lable := "LongTimeParallel"
		fmt.Println(event_lable)
		ObjectSlice = make(map[uint32][][]float32)
	}

	if Maxlenobj >= 250 {
		ObjectSlice = make(map[uint32][][]float32)
		Maxlenobj = 0
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.AbsSpeed = math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))

}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	for _, obj := range data.Objs {
		if math.Abs(float64(obj.X)) >= 52 || math.Abs(float64(obj.Y)) >= 10 {
			continue
		}
		if _, ok := ObjectSlice[obj.Id]; !ok {
			ObjectSlice[obj.Id] = [][]float32{{}, {}}
		}
		ObjectSlice[obj.Id][0] = append(ObjectSlice[obj.Id][0], obj.X)
		ObjectSlice[obj.Id][1] = append(ObjectSlice[obj.Id][1], obj.Y)
	}
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
