package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
)

// //道路坡度大于6%就可以被认为是陡坡
var (
	param            entity.PjisuvParam
	threshold        = 0.05
	count1           = 0
	UphillPointSlice = [][]float64{{}, {}}
	CountNoneUphill  = 0
)

type Point struct {
	X float64
	Y float64
}

func main() {
	go listener()
	for {
		select {}
	}
}

// 计算两点之间的距离（米）
func distance(point1, point2 Point) float64 {

	d := math.Sqrt((point2.X-point1.X)*(point2.X-point1.X) + (point2.Y-point1.Y)*(point2.Y-point1.Y))

	return d
}

// QuaternionToEuler 将四元数转换为欧拉角
func QuaternionToEuler(x, y, z, w float64) float64 {
	// 归一化四元数
	length := math.Sqrt(x*x + y*y + z*z + w*w)
	x /= length
	y /= length
	z /= length
	w /= length
	// 计算欧拉角
	pitch := math.Asin(2 * (w*y - z*x))
	if math.IsNaN(pitch) {
		return 0.0
	}
	return pitch
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	if count1%1 == 0 {
		pitch := QuaternionToEuler(data.Qx, data.Qy, data.Qz, data.Qw)
		//fmt.Println(pitch)
		if pitch >= threshold {
			UphillPointSlice[0] = append(UphillPointSlice[0], data.PositionX)
			UphillPointSlice[1] = append(UphillPointSlice[1], data.PositionY)
			if len(UphillPointSlice[0]) > 250 {

				P1 := Point{UphillPointSlice[0][0], UphillPointSlice[1][0]}
				P2 := Point{UphillPointSlice[0][len(UphillPointSlice[0])-1], UphillPointSlice[1][len(UphillPointSlice[1])-1]}
				distance := distance(P1, P2)
				if distance >= 100 {
					event_lable := "LongUphill"
					fmt.Println(event_lable)
				}
				CountNoneUphill = 0
				UphillPointSlice = [][]float64{{}, {}}
			}
		} else {
			CountNoneUphill++
			if CountNoneUphill == 4 {
				if len(UphillPointSlice[0]) > 1 {
					P1 := Point{UphillPointSlice[0][0], UphillPointSlice[1][0]}
					P2 := Point{UphillPointSlice[0][len(UphillPointSlice[0])-1], UphillPointSlice[1][len(UphillPointSlice[1])-1]}
					distance := distance(P1, P2)
					if distance >= 100 {
						event_lable := "LongUphill"
						fmt.Println(event_lable)
					}
					UphillPointSlice = [][]float64{{}, {}}
				}
				CountNoneUphill = 0
			}
		}
	}
	count1++
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
