package main

import (
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	count     int64   = 0
	threshold float64 = 25 / 3.6
)

func Ifatnight() bool {
	// 获取当前时间
	now := time.Now()
	later := now.Add(0 * time.Hour)
	// 获取当前小时
	hour := later.Hour()
	// 判断当前时间是白天还是夜晚
	if hour >= 0 && hour < 5 || hour >= 20 && hour <= 23 {
		return true
	} else {
		return false
	}
}
func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	if count%100 == 0 {
		if Ifatnight() {
			AbsSpeed := math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))
			if AbsSpeed >= threshold {
				eventLabel := "OverspeedAtNight"
				fmt.Println(eventLabel)
			}
		}
		count = 1
	}
	count++

}
func main() {
	go listener()
	select {}
	//time.Sleep(10000)
}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	//sort.Float64s(numbers)
	//max := numbers[len(numbers)-1]
	//fmt.Println("最大值为:", max)
	signal.Notify(c, os.Interrupt)
	<-c
}
