package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	threshold   float64 = 3 / 3.6
	Maxlenobj   int32   = 0
	param       entity.PjisuvParam
	ObjectSlice = make(map[uint32][][]float32)
)

func main() {
	ticker := time.NewTicker(2 * time.Second)
	defer ticker.Stop()
	go listener()
	for {
		select {
		case <-ticker.C:
			FinalCallback()
		}
	}
}

func IsOvertaken(ObjectList [][]float32) bool {
	if param.AbsSpeed > threshold {
		//fmt.Println("yes")
		//fmt.Println(ObjectList)
		for i, objX := range ObjectList[0] {
			diffangle := math.Abs(param.YawOfCicvLocation - float64(ObjectList[2][i]))

			if ObjectList[1][i] >= -0.6 && ObjectList[1][i] <= 4 && objX >= 2.5 && diffangle <= 90.0 {
				for j := 0; j < len(ObjectList[0])-i-1; j++ {
					if ObjectList[1][1+i+j] >= -0.6 && ObjectList[1][1+i+j] <= 4 && ObjectList[0][1+i+j] <= -1.0 {
						return true
					}
				}
			}
		}
	}
	return false
}
func FinalCallback() {
	//fmt.Println("here")
	for _, objValue := range ObjectSlice {
		//fmt.Println(ObjectSlice)
		//fmt.Println(objValue)
		//fmt.Println("------------------------------------------------")
		Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
		if len(objValue[0]) <= 5 || !IsOvertaken(objValue) {
			continue
		}
		event_lable := "OvertakingRight"
		fmt.Println(event_lable)
		ObjectSlice = make(map[uint32][][]float32)
	}

	//fmt.Println(Maxlenobj)
	if Maxlenobj >= 120 {
		ObjectSlice = make(map[uint32][][]float32)
		Maxlenobj = 0
	}
}

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.AbsSpeed = math.Sqrt(math.Pow(data.VelocityX, 2) + math.Pow(data.VelocityY, 2))
	param.YawOfCicvLocation = data.Yaw
}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	for _, obj := range data.Objs {
		if math.Abs(float64(obj.X)) >= 50 || math.Abs(float64(obj.Y)) >= 60 {
			continue
		}
		if _, ok := ObjectSlice[obj.Id]; !ok {
			ObjectSlice[obj.Id] = [][]float32{{}, {}, {}}
		}
		ObjectSlice[obj.Id][0] = append(ObjectSlice[obj.Id][0], obj.X)
		ObjectSlice[obj.Id][1] = append(ObjectSlice[obj.Id][1], obj.Y)
		ObjectSlice[obj.Id][2] = append(ObjectSlice[obj.Id][2], obj.Heading)
		//ObjectSlice[obj.Id][2] = append(ObjectSlice[obj.Id][2], obj.Vxrel)
	}
}
func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
