package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
	"time"
)

var (
	param     entity.PjisuvParam
	StartTime = time.Now().Unix()
)

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.AngularVelocityZOfCicvLocation = data.AngularVelocityZ
	param.VelocityXOfCicvLocation = data.VelocityX

}

func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	for _, obj := range data.Objs {
		//fmt.Println(param.VelocityXOfCicvLocation)
		if math.Abs(float64(obj.Y)) <= 1.5 && obj.X >= 0 && obj.X <= 6 && param.AngularVelocityZOfCicvLocation < 5.5 && math.Abs(param.VelocityXOfCicvLocation) >= 0.5 {
			event_label := "TargetAhead" //测试车正前方１０米范围内有目标物（过滤掉测试车转弯的情况）
			fmt.Println(event_label)
			duration := time.Now().Unix() - StartTime
			fmt.Println(duration)

			//return "TargetAhead"
		}
	}
	//return ""

}

func main() {

	go listener()
	select {}
	//time.Sleep(10000)
}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
