package main

import (
	"fmt"
	"math"
)

// 计算车辆速度方向角，并将结果限定在 0~360 范围内
func calculateDirectionAngle(speedX, speedY float64) float64 {
	// 使用反正切函数计算方向角
	angle := math.Atan2(speedY, speedX)

	// 将角度转换为度数
	angleDegree := angle * (180 / math.Pi)

	// 将角度限定在 0~360 范围内
	if angleDegree < 0 {
		angleDegree += 360
	} else if angleDegree > 360 {
		angleDegree -= 360
	}

	return angleDegree
}

func main() {
	// 定义速度分量
	speedX := -1.18660616875
	speedY := 2.20820569992

	// 计算方向角
	directionAngle := calculateDirectionAngle(speedX, speedY)

	// 输出结果
	fmt.Println("车辆速度的方向角为:", directionAngle, "度")
}
