package main

import (
	"awesomeProject/entity"
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
)

var param entity.PjisuvParam

func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	param.VelocityXOfCicvLocation = data.VelocityX

}
func CallbackTpperception(data *pjisuv_msgs.PerceptionObjects) {
	NumTargets := 0
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()

	if param.VelocityXOfCicvLocation < 2.5 && len(data.Objs) > 3 {
		for _, obj := range data.Objs {
			if obj.Type == 0 && math.Abs(float64(obj.Y)) <= 2.5 && math.Abs(float64(obj.X)) <= 20 && obj.Speed <= 4 {
				NumTargets++
			}
		}
		//fmt.Println(NumTargets)
		if NumTargets >= 3 {
			//event_lable := "NumTargetsExceedThreshold"
			fmt.Printf("TrafficCongestion")
		}
	}

}

func main() {

	go listener()
	select {}
	//time.Sleep(10000)
}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()
	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// create a subscriber
	subTpperception, err := goroslib.NewSubscriber(goroslib.SubscriberConf{

		Node:     n,
		Topic:    "tpperception",
		Callback: CallbackTpperception,
	})
	if err != nil {
		panic(err)
	}
	defer subTpperception.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
