package main

import (
	"awesomeProject/pjisuv_msgs"
	"fmt"
	"github.com/bluenviron/goroslib/v2"
	"math"
	"os"
	"os/signal"
)

var (
	count    int = 0
	Yowslice     = make([]float64, 0)
)

func IfTurnAround() bool {
	diffangle := math.Abs(Yowslice[0] - Yowslice[len(Yowslice)-1])
	//fmt.Println(diffangle)
	if diffangle >= 110 {
		return true
	}
	return false
}
func CallbackCicvLocation(data *pjisuv_msgs.PerceptionLocalization) {
	Yowslice = append(Yowslice, data.Yaw)
	if len(Yowslice) >= 250 {
		Yowslice = Yowslice[1:]
	}
	if count%10 == 0 {
		if IfTurnAround() {
			eventLabel := "TurnAround"
			fmt.Println(eventLabel)
			Yowslice = make([]float64, 0)
		}
		count = 1
	}
	count++
}
func main() {
	go listener()
	select {}
	//time.Sleep(10000)
}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCicvLocation, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/cicv_location",
		Callback: CallbackCicvLocation,
	})
	if err != nil {
		panic(err)
	}
	defer subCicvLocation.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
