package main

import (
	pji_msgs "awesomeProject/pjibot_delivery_msgs"
	"fmt"

	"github.com/bluenviron/goroslib/v2"
	"os"
	"os/signal"
)

func CallbackTaskFeedbackInfo(data *pji_msgs.TaskFeedbackInfo) {
	if data.TaskErrorCode != 0 {
		eventLabel := "TaskFailed"
		fmt.Println(eventLabel)
	}

}

func main() {
	go listener()
	select {}
	//time.Sleep(10000)
}

func listener() {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	subCallbackTaskFeedbackInfo, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:     n,
		Topic:    "/task_feedback_info",
		Callback: CallbackTaskFeedbackInfo,
	})
	if err != nil {
		panic(err)
	}
	defer subCallbackTaskFeedbackInfo.Close()

	// wait for CTRL-C
	c := make(chan os.Signal, 1)
	signal.Notify(c, os.Interrupt)
	<-c
}
